/* Copyright (c) 2002, Marek Michalkiewicz <marekm@amelek.gda.pl>
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:

   * Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.

   * Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in
     the documentation and/or other materials provided with the
     distribution.

   * Neither the name of the copyright holders nor the names of
     contributors may be used to endorse or promote products derived
     from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
   POSSIBILITY OF SUCH DAMAGE. */

/* $Id: crt.S,v 1.2 2007/08/10 03:17:48 iruka Exp $ */

#if (__GNUC__ < 3) || (__GNUC__ == 3 && __GNUC_MINOR__ < 3)
#error "GCC version >= 3.3 required"
#endif

// *******************************************************
// 		attiny2313p	int0̂ݎgp.
// *******************************************************
#if defined (__AVR_ATmega168__)
#define	VECSIZE		12	// RESET, INT0, INT1 ̂R݂̂L
#else
// ATmega88, ATtiny2313
#define	VECSIZE		6	// RESET, INT0, INT1 ̂R݂̂L
#endif

// *******************************************************
// 		.dataZNVstaticf[^Rs[.
// *******************************************************
#define	DO_COPY_DATA	1	// .dataTCY0̂Ƃ0.

// *******************************************************
// 		.bss ZNV[NA.
// *******************************************************
#define	DO_CLEAR_BSS	1	// .bssTCY 0̂Ƃ0.


#include "macros.inc"

	.macro	vector name
	.if (. - __vectors < VECSIZE)
	.weak	\name
	.set	\name, __bad_interrupt
	XJMP	\name
	.endif
	.endm

	.section .vectors,"ax",@progbits
	.global	__vectors
	.func	__vectors
__vectors:
	XJMP	__init		; ZbgdON, WDT, BOD̊e탊Zbg
#if defined (__AVR_ATtiny2313__)
	vector	__vector_1	; EXT_INT0	 ;O荞ݗv0
	vector	__vector_2	; EXT_INT1	 ;O荞ݗv1
	vector	__vector_3	; TIM1_CAPT	 ;^C}/JE^1 ߊl(Lv`)
	vector	__vector_4	; TIM1_COMPA	 ;^C}/JE^1 rAv
	vector	__vector_5	; TIM1_OVF	 ;^C}/JE^1 I[o[t[
	vector	__vector_6	; TIM0_OVF	 ;^C}/JE^0 I[o[t[
	vector	__vector_7	; USART_RXC	 ;USART M
	vector	__vector_8	; USART_UDRE	 ;USART Mobt@
	vector	__vector_9	; USART_TX	 ;USART M
	vector	__vector_10	; ANA_COMP	 ;AiOro͑J
	vector	__vector_11	; PCINT	 ;sω荞ݗv
	vector	__vector_12	; TIM1_COMPB	 ;^C}/JE^1 rBv
	vector	__vector_13	; TIM0_COMPA	 ;^C}/JE^0 rAv
	vector	__vector_14	; TIM0_COMPB	 ;^C}/JE^0 rBv
	vector	__vector_15	; USI_STRT	 ;USI Jno
	vector	__vector_16	; USI_OVF	 ;USI JE^ I[o[t[
	vector	__vector_17	; EE_RDY	 ;EEPROM
	vector	__vector_18	; WDT_OVF	 ;EHb`hbOv
#else
	vector	__vector_1	; INT0 O荞ݗv0
	vector	__vector_2	; INT1 O荞ݗv1
	vector	__vector_3	; PCINT0 (PCI0) sω荞ݗv0
	vector	__vector_4	; PCINT1 (PCI1) sω荞ݗv1
	vector	__vector_5	; PCINT2 (PCI2) sω荞ݗv2
	vector	__vector_6	; EHb`hbO WDT EHb`hbOv
	vector	__vector_7	; ^C}/JE^2 COMPA ^C}/JE^2rAv
	vector	__vector_8	; ^C}/JE^2 COMPB ^C}/JE^2rBv
	vector	__vector_9	; ^C}/JE^2 OVF ^C}/JE^2
	vector	__vector_10	; ^C}/JE^1 CAPT ^C}/JE^1ߊl
	vector	__vector_11	; ^C}/JE^1 COMPA ^C}/JE^1rAv
	vector	__vector_12	; ^C}/JE^1 COMPB ^C}/JE^1rBv
	vector	__vector_13	; ^C}/JE^1 OVF ^C}/JE^1
	vector	__vector_14	; ^C}/JE^0 COMPA ^C}/JE^0rAv
	vector	__vector_15	; ^C}/JE^0 COMPB ^C}/JE^0rBv
	vector	__vector_16	; ^C}/JE^0 OVF ^C}/JE^0
	vector	__vector_17	; SPI STC SPI ]
	vector	__vector_18	; USART RX USART M
	vector	__vector_19	; USART UDRE USART Mobt@
	vector	__vector_20	; USART TX USART M
	vector	__vector_21	; A/Dϊ ADC A/Dϊ
	vector	__vector_22	; EEPROM EE_RDY EEPROM 
	vector	__vector_23	; AiOr ANA_COMP AiOro͑J
	vector	__vector_24	; 2C^[tF[X TWI 2C^[tF[Xԕω
	vector	__vector_25	; SPM SPM_RDY SPMߑ
#endif
	.endfunc

	/* Handle unexpected interrupts (enabled and no handler), which
	   usually indicate a bug.  Jump to the __vector_default function
	   if defined by the user, otherwise jump to the reset address.

	   This must be in a different section, otherwise the assembler
	   will resolve "rjmp" offsets and there will be no relocs.  */

	.section .init0,"ax",@progbits
	.weak	__init
;	.func	__init
__init:
__bad_interrupt:

	.weak	exit
exit:

#ifndef __AVR_ASM_ONLY__
	.weak	__stack

	/* By default, malloc() uses the current value of the stack pointer
	   minus __malloc_margin as the highest available address.

	   In some applications with external SRAM, the stack can be below
	   the data section (in the internal SRAM - faster), and __heap_end
	   should be set to the highest address available for malloc().  */
	.weak	__heap_end
	.set	__heap_end, 0

	.section .init2,"ax",@progbits
	clr	__zero_reg__
	out	_SFR_IO_ADDR(SREG), __zero_reg__
	ldi	r28,lo8(__stack)
	ldi	r29,hi8(__stack)

	out	_SFR_IO_ADDR(SPL), r28
	out	_SFR_IO_ADDR(SPH), r29

	.section .init4,"ax",@progbits
	.global __do_copy_data
	.global __do_clear_bss

// *******************************************************
// attiny2313p:
// .data , .bss ̏ʃAhX͏ɂOłƉ.
// *******************************************************

__do_copy_data:
	ldi	r17, hi8(__data_end)

	// Y r26:27 = f[^̃Rs[SRAMAhX.
	ldi	r26, lo8(__data_start)
	ldi	r27, hi8(__data_start)

	// Z r30:31 = staticf[^̃Rs[ROMAhX.
	ldi	r30, lo8(__data_load_start)
	ldi	r31, hi8(__data_load_start)


// *******************************************************
// 		.dataZNVstaticf[^Rs[.
// *******************************************************
#if	DO_COPY_DATA
// *******************************************************
// .data  ̃TCY͔[.
//	rjmp	.do_copy_data_start
// *******************************************************

.do_copy_data_loop:
	lpm r0, Z+
	st	X+, r0

.do_copy_data_start:
	cpi	r26, lo8(__data_end)
	cpc	r27, r17

// *******************************************************
// attiny2313p:
// .data , .bss ̏ʃAhX͏ɂOłƉ.
//	cpc	r27, r17
// *******************************************************

	brne	.do_copy_data_loop

#endif	// DO_COPY_DATA

// *******************************************************
// 		.bss ZNV[NA.
// *******************************************************
#if	DO_CLEAR_BSS

__do_clear_bss:

// *******************************************************
// .data ̒.bssƉ.
// .bss  ̃TCY͔[.
// *******************************************************
	ldi	r17, hi8(__bss_end)
//	ldi	r26, lo8(__bss_start)
//	ldi	r27, hi8(__bss_start)
//	rjmp	.do_clear_bss_start


.do_clear_bss_loop:
	st	X+, r1
.do_clear_bss_start:
	cpi	r26, lo8(__bss_end)
	cpc	r27, r17
	brne	.do_clear_bss_loop

#endif	//	DO_CLEAR_BSS

	.set	__stack, RAMEND

#endif /* !__AVR_ASM_ONLY__ */

	.section .init9,"ax",@progbits
	XJMP	main

;	.endfunc

